﻿using System;
using System.Globalization;
using System.Windows.Data;


namespace DoubleTextBoxDemo
{
    public sealed class NumericInputConverter : IValueConverter
    {


        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            try
            {
                if (targetType != typeof(object))
                {
                    double val=(double)value;
                    // Formatierung bei Eingabefeldern
                    if (value != null)
                    {
                        string result = String.Empty;

                        result = value.ToString();
                        if (!value.ToString().Contains("."))
                        {
                            decimal _formatted = System.Convert.ToDecimal(value) / 100;

                            result = _formatted.ToString("F");
                        }
                        else if (value.ToString().Contains("."))
                        {
                            decimal _formatted = System.Convert.ToDecimal(value);

                            result = string.Format("{0:F2}", _formatted);
                        }

                        return result.ToString();
                    }
                }
                else
                {
                    // Formatierung bei nicht Eingabefeldern
                    if (value == String.Empty)
                    {
                        value = 0;
                    }

                    decimal _formattedcomputed = System.Convert.ToDecimal(value);
                    string resultcomputed = string.Format("{0:F2}", _formattedcomputed);

                    return resultcomputed;
                }
            }
            catch (Exception ex)
            {

            }

            return null;
        }


        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            try
            {
                if (targetType == typeof(decimal))
                {
                    decimal result = 0;

                    if (!value.ToString().Contains("."))
                    {
                        decimal _formatted = System.Convert.ToDecimal(value) / 100;

                        result = System.Convert.ToDecimal(_formatted.ToString("F"));
                    }
                    else if (value.ToString().Contains("."))
                    {
                        decimal _formatted = System.Convert.ToDecimal(value);

                        result = System.Convert.ToDecimal(string.Format("{0:F2}", _formatted));
                    }
                    return result;
                }
                else if (targetType == typeof(string))
                {
                    return value;
                }
                else if (targetType != typeof(object))
                    return value;
            }
            catch (Exception ex)
            {
            }

            return null;
            // return value;
        }
    }
}
